{$apptype console}
{$i+,s+,q+,r+}

const maxm=10000;
      maxn=1000;
var n,m:longint;
    st:array[1..maxm] of longint;
    fn:array[1..maxm] of longint;
    typ:array[1..maxm] of longint;
    p:array[1..maxn] of longint;
    rank:array[1..maxn] of longint;
    _p:array[1..maxn] of longint;
    _rank:array[1..maxn] of longint;
    destroy:array[1..maxm] of boolean;
    havesol:boolean;

procedure inputdata;
var i:longint;
begin
 assign(input,'input.txt');
 reset(input);
 read(n,m);
 for i:=1 to m do
  read(st[i],fn[i],typ[i]);
 close(input);
end;

function findset(x:longint):longint;
begin
 if x<>p[x]
  then p[x]:=findset(p[x]);
 result:=p[x];
end;

procedure union(a,b:longint);
begin
 if rank[a]<rank[b]
  then p[a]:=b
  else begin
   p[b]:=a;
   if rank[a]=rank[b]
    then inc(rank[a]);
  end;
end;

procedure solve;
var i:longint;
    compcnt:longint;
    _compcnt:longint;
begin
 havesol:=true;
 for i:=1 to n do
  begin
   p[i]:=i;
   rank[i]:=1;
  end;
 fillchar(destroy,sizeof(destroy),1);
 compcnt:=n;
 for i:=1 to m do
  if (typ[i]=3) and (findset(st[i])<>findset(fn[i]))
   then begin
    dec(compcnt);
    destroy[i]:=false;
    union(findset(st[i]),findset(fn[i]));
   end;
 for i:=1 to n do
  begin
   _p[i]:=p[i];
   _rank[i]:=rank[i];
  end;
 _compcnt:=compcnt;
 for i:=1 to m do
  if (typ[i]=1) and (findset(st[i])<>findset(fn[i]))
   then begin
    dec(compcnt);
    destroy[i]:=false;
    union(findset(st[i]),findset(fn[i]));
   end;
 if compcnt<>1
  then begin
   havesol:=false;
   exit;
  end;
 for i:= 1 to n do
  begin
   p[i]:=_p[i];
   rank[i]:=_rank[i];
  end;
 compcnt:= _compcnt;
 for i:=1 to m do
  if (typ[i]=2) and (findset(st[i])<>findset(fn[i]))
   then begin
    dec(compcnt);
    destroy[i]:=false;
    union(findset(st[i]),findset(fn[i]));
   end;
 if compcnt<>1
  then havesol:=false;
end;

procedure writedata;
var cnt:longint;
    i:longint;
    first:boolean;
begin
 assign(output,'output.txt');
 rewrite(output);
 if not havesol
  then writeln(-1)
  else begin
   cnt:=0;
   for i:=1 to m do
    if destroy[i]
     then inc(cnt);
   writeln(cnt);
   first:=true;
   for i:=1 to m do
    if destroy[i]
     then begin
      if not first
       then write(' ');
      first:=false;
      write(i);
     end;
    writeln;
  end;
 close(output);
end;

begin
 inputdata;
 solve;
 writedata;
end.