{$apptype console}
{$i+,s+,q+,r+}
{$maxstacksize 1000000}

uses sysutils;
const maxl=10000;
      module=10000;
      lgmodule=4;
type tlong=array[1..maxl] of longint;
var n:longint;
    a:tlong;

procedure lmul(var a:tlong;
              b:longint);
var i:longint;
begin
 for i:=1 to maxl do
  a[i]:=a[i]*b;
 for i:=1 to maxl-1 do
  begin
   inc(a[i+1],a[i] div module);
   a[i]:=a[i] mod module;
  end;
end;

function isprime(x:longint):boolean;
var i:longint;
begin
 result:=true;
 for i:=2 to trunc(sqrt(x)) do
  if x mod i=0
   then result:=false;
end;

procedure inputdata;
begin
 assign(input,'input.txt');
 reset(input);
 readln(n);
 close(input);
end;

procedure solve;
var i:longint;
begin
 fillchar(a,sizeof(a),0);
 a[1]:=1;
 for i:=2 to n do
  if not isprime(i)
   then lmul(a,i)
   else lmul(a,i-1);
end;

procedure writedata;
var i:longint;
    j:longint;
    s:ansistring;
begin
 assign(output,'output.txt');
 rewrite(output);
 j:=maxl;
 while a[j]=0 do
  dec(j);
 write(a[j]);
 for i:=j-1 downto 1 do
  begin
   s:= inttostr(a[i]);
   while length(s)<lgmodule do
    s:= '0'+s;
   write(s);
  end;
 writeln;
 close(output);
end;

begin
 inputdata;
 solve;
 writedata;
end.