#include <stdio.h>
#include <queue>
#include <functional>

using namespace std;

priority_queue<pair<long,long>,vector<pair<long,long> >, greater<pair<long,long> > >qa;
priority_queue<long,vector<long>,greater<long> > qf;

long *rz, *len;
long k, n, z, m, l, r2, r1, t2;

void process()
{
	long start=qa.top().first, last=0;
	pair<long,long> thePair;

	while (!qa.empty())	{
		while (!qf.empty() && qf.top()<qa.top().first) qf.pop();
		
		if (qf.size()<k){
			qf.push(qa.top().first+len[qa.top().second]);
			qa.pop();
		} 
			else
		{
			thePair=qa.top();
			qa.pop();
			
			if (rz[thePair.second]==m) {
				++r1;
				r2-=len[thePair.second];
			}	
				else
			{
				thePair.first+=z;
				++rz[thePair.second];
				qa.push(thePair);
			}
		}
	}

	while (!qf.empty())	{
		last=qf.top();
		qf.pop();
	}

	t2=last-start;
}

void outdata()
{
	FILE *f = fopen("output.txt","w");
	fprintf(f,"%d %.3f\n",r1,(double)r2/t2);
	fclose(f);
}

int main() {

	FILE *fin=fopen("input.txt","r");
	fscanf(fin,"%d%d%d%d",&k,&z,&m,&l);

	pair<long,long> tmp;
	rz=new long[l+1];
	len=new long[l+1];
	memset(rz,0,sizeof(long)*(l+1));

	for (long i=0;i<l;++i) {
		fscanf(fin,"%d%d",&tmp.first,&len[i+1]);
		r2+=len[i+1];
		tmp.second=i+1;
		qa.push(tmp);
	}
	
	fclose(fin);

	process();

	FILE *fout=fopen("output.txt","w");
	fprintf(fout,"%d %.3f\n",r1,(double)r2/t2);
	fclose(fout);

	return 0;
}