{$apptype console}
{$i-,s-,q-,r-,o+}

uses math;
const maxl=10000;
      maxt=2500000;
      eps=1e-10;
type plist=^tlist;
     tlist=record
      id:longint;
      next:plist;
     end;
var K:longint;
    Z:longint;
    N:longint;
    L:longint;
    a:array[1..maxl] of longint;
    b:array[1..maxl] of longint;
    recalls:array[1..maxl] of longint;
    c_busy:array[1..maxt] of longint;
    start_calls:array[1..maxt] of plist;
    finish_calls:array[1..maxt] of word;
    R1:longint;
    R2:longint;
    T:longint;

procedure inputdata;
var i:longint;
begin
 assign(input,'input.txt');
 reset(input);
 read(K,Z,N);
 read(L);
 for i:=1 to L do
  read(a[i],b[i]);
 close(input);
end;

procedure add(var a:plist;
              id:longint);
var x:plist;
begin
 new(x);
 x^.id:=id;
 x^.next:=a;
 a:=x;
end;

procedure solve;
var c_op:longint;
    i:longint;
    j:longint;
    adj:plist;
    id:array[1..maxl] of longint;
    idcnt:longint;
    lt:longint;
    rt:longint;
    old_c_op:longint;

function partition(l:longint;
                   r:longint):longint;
var i:longint;
    j:longint;
    X:longint;
    S:longint;
begin
 i:=l-1;
 j:=r+1;
 X:=id[l+random(r-l+1)];
 while true do
  begin
   repeat
    dec(j)
   until id[j]<=X;
   repeat
    inc(i)
   until id[i]>=X;
   if i<j
    then begin
     S:=id[i];
     id[i]:=id[j];
     id[j]:=S;
    end
    else begin
     result:=j;
     exit;
    end;
  end;
end;

procedure sort(l:longint;
               r:longint);
var q:longint;
begin
 if l<r
  then begin
   q:=partition(l,r);
   sort(l,q);
   sort(q+1,r);
  end;
end;

begin
 c_op:=K;
 for i:=1 to L do
  begin
   add(start_calls[a[i]], i);
   recalls[i]:=N;
  end;
 R1:=0;
 for i:=1 to maxt do
  begin
   adj:=start_calls[i];
   idcnt:=0;
   while adj<>nil do
    begin
     inc(idcnt);
     id[idcnt]:=adj^.id;
     adj:=adj^.next;
    end;
   sort(1,idcnt);
   old_c_op:=c_op;
   for j:=1 to min(old_c_op,idcnt) do
    begin
     inc(finish_calls[i+b[id[j]]]);
     dec(c_op);
    end;
   for j:=min(old_c_op,idcnt)+1 to idcnt do
    if recalls[id[j]]>0
     then begin
      add(start_calls[i+Z],id[j]);
      dec(recalls[id[j]]);
     end
     else inc(R1);
   inc(c_op, finish_calls[i]);
   c_busy[i]:=K-c_op;
  end;
 R2:=0;
 for i:=1 to maxt do
  inc(R2,c_busy[i]);
 lt:=1;
 while (c_busy[lt]=0) do
  inc(lt);
 rt:=maxt;
 while (c_busy[rt]=0) do
  dec(rt);
 T:=rt-lt+1;
end;

procedure writedata;
begin
 assign(output,'output.txt');
 rewrite(output);
 writeln(R1,' ',(R2/T+eps):0:3);
 close(output);
end;

begin
 inputdata;
 solve;
 writedata;
end.